#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

char		 buf[BUFSIZ];
const char	*utf8bom = "\xef\xbb\xbf";

static void	 usage(const char *);

static void
usage(const char *prog)
{
	fprintf(stderr, "usage: %s\n", prog);
	exit(1);
}

int
main(int argc, const char * const argv[])
{
	size_t nread;

	if (argc > 1)
		usage(argv[0]);

	nread = fread(buf, 1, strlen(utf8bom), stdin);
	if (nread == 0)
		return 0;
	if (strcmp(buf, utf8bom) != 0)
		if (fwrite(buf, 1, nread, stdout) < nread)
			exit(1);
	for (;;) {
		nread = fread(buf, 1, sizeof buf, stdin);
		if (nread == 0)
			return ferror(stdin) && 1;
		if (fwrite(buf, 1, nread, stdout) < nread)
			exit(1);
	}
	return 0;
}
